#include "mol.h"
#include "parsmart.h"
#include "OBGrep.h"
#include <unistd.h>
#include <vector>
#include <algorithm>
#include <sstream>


using namespace std;
using namespace OpenBabel;

char *program_name="OBGrep";
int  numberOfDBEntries = -1;

int   dbCount = 0;
int   *databaseEntries = new int[20];
//OBMol **database       = new (OBMol*)[20];
//int   **matchSet       = new (int*)[20];
OBMol **database       = new OBMol* [20];
int   **matchSet       = new int* [20];
int   *matchSetSize    = new int[20];
int   sizeLastMatch    ; 



void freeMatching(int* a) { delete[]a; }

int loadDB(char *FileIn)
{
  io_type inFileType  = UNDEFINED;
  io_type outFileType = UNDEFINED;
  int c = 0;

  //cerr << program_name << " reached loadDB\n";
  //cerr << program_name << " " << FileIn << "\n";

  if (extab.CanReadExtension(FileIn))
    inFileType = extab.FilenameToType(FileIn);
  else
  {
    cerr << program_name << ": cannot read input format!" << endl;
    return -1;
  }
  if (extab.CanWriteExtension(FileIn))
    outFileType = extab.FilenameToType(FileIn);
  else
  {
    cerr << program_name << ": cannot write input format!" << endl;
    return -2;
  }
  
  ifstream ifs;
    // Read the file
  //cerr << program_name << ": open file\n";
  ifs.open(FileIn);
  //cerr << program_name << ": reading file\n";
  if (!ifs)
  {
    cerr << program_name << ": cannot read input file!" << endl;
    return -3;
  }
  
  //  database  =
  //cerr << program_name << ": trying to allocate space1\n";
  database[dbCount] = new OBMol[60000];
  //cerr << program_name << ": trying to allocate space2\n";
  databaseEntries[dbCount] = 0;
  //cerr << program_name << ": prepare read\n";
  OBMol mol(inFileType, outFileType);
  int count = 0;

  //cerr << program_name << ": reading\n";

  // Search for pattern
  for (c=0;;c++)
  {
    //cerr << program_name << " " << c << "\n";
    OBMol mol(inFileType, outFileType);

    database[dbCount][c] = mol;
    //    mol.Clear();
    ifs >> database[dbCount][c];
    if (database[dbCount][c].Empty()) break;
    databaseEntries[dbCount]++;
  }

  // setting the current Match set (is all at the beginning)

  matchSet[dbCount] = new int[databaseEntries[dbCount]];
  matchSetSize[dbCount] = databaseEntries[dbCount];
  for (c=0;c<databaseEntries[dbCount];c++)
  {
    matchSet[dbCount][c] = c+1;
  }
  
  // just in case
  sizeLastMatch = 0;

  dbCount++;
  return dbCount-1;
}

int getNumEntries(int dbCount)
{
  //cerr << program_name << " pattern search\n";
  //cerr << program_name << ":dbCount:\t" << dbCount <<" \n";
  return databaseEntries[dbCount];
}


void testIntegrity(int dbNum)
{
  /* int c;
  string theMolecule;
  char *buffer;
  for(c=0;c<databaseEntries[dbNum];c++)
  {
    theMolecule = getEntryString(dbNum, c+1);
    buffer = const_cast<char*> (theMolecule);
    cout << c << ":" << buffer;
    match(dbNum,  buffer);
   
    }*/
  return ;
  
}
void printDB(int dbNum)
{
  int c;
  for(c=0;c<databaseEntries[dbNum];c++)
  {
    cout << c << ":" << database[dbNum][c] ;
  }
  //testIntegrity(dbNum);
  return;
}

int match(int dbNum,char *pattern)
{
  //cerr << program_name << " pattern search\n";
  //cerr << program_name << ":dbNum:\t" << dbNum <<" \n";
  //cerr << program_name << ":pattern:\t" << pattern <<" \n";
  OBSmartsPattern sp;
  int count = 0;
  int c;

  sp.Init(pattern);
 
  for(c=0;c<databaseEntries[dbNum];c++)
  {
    //cerr << program_name << ":c:\t" << c <<" \n";
   
    if (sp.Match(database[dbNum][c]) )  // perform SMART matching
    {
	  count++;
    }    
  }
  return count;
}

string getEntryString(int dbNum, int entryNum)
{
  stringstream a;
  //  string returnString;
  if (databaseEntries[dbNum]>= entryNum)
    {
      a << database[dbNum][entryNum-1];
       //cerr << program_name << ":a:\t" << a <<"\n" ;  
       //cerr << program_name << ":pattern:\t" << (a.str()).c_str() ;
       //cerr << program_name << ":database[dbNum][entryNum-1]:\t" << database[dbNum][entryNum-1] << "\n" ;
      //returnString = (database[dbNum][entryNum-1]).GetName() ;
      //return returnString;
    }
  else
    {
      a << "Entry number too big : " << databaseEntries[dbNum] << " >= "<< entryNum << "\n"  ;   
    }
  //return (a.str()).c_str();
  return a.str();
}

void printEntry(int dbNum, int entryNum)
{
  if (databaseEntries[dbNum]>= entryNum)
    {
      cout << "Entry number " << entryNum << ": " << database[dbNum][entryNum-1] << "\n";
    }
  else
    {
      cout << "Entry number too big : " << databaseEntries[dbNum] << " >= "<< entryNum << "\n"  ;   
    }
}

void setCurrentMatchSet(int dbNum, int *newMatchSet)
{
  if(matchSet[dbNum]!=NULL)
  {
    freeMatching(matchSet[dbNum]);
  }
  matchSet[dbNum] = newMatchSet;
}

void setCurrentMatchSetSize(int dbNum, int size)
{
  matchSetSize[dbNum] = size;
}

int* getCurrentMatchSet(int dbNum)
{
  return matchSet[dbNum];
}

int getCurrentMatchSetSize(int dbNum)
{
  return matchSetSize[dbNum];
}

int matchMode(int dbNum,char *pattern, int mode, int maxNum)
{
  int count = 0;
  int matchSetCount = 0;
  int c;

  OBSmartsPattern sp;
  sp.Init(pattern);
  
  switch (mode)
    {
    case MATCH_FULL:
      c = 0;
      break;
    case MATCH_IN_SET:
      // start with the first entry in the match set (if match set is not empty)
      if (matchSetSize[dbNum] > 0)
      {
	c =  matchSet[dbNum][0]-1;
      }
      else
      {
	c = databaseEntries[dbNum];
      }
      break;
    case MATCH_NOT_IN_SET:
      c = 0;
      if (matchSetSize[dbNum] > 0)
      {
	// find starting point
	while((c<databaseEntries[dbNum])&&(c == matchSet[dbNum][0]-1))
	  c++;
      }
      else
      {
	mode = MATCH_FULL;
      }
      break;
    }

  for(;c<databaseEntries[dbNum];c++)
  {
    
    switch (mode)
    {
      case MATCH_FULL:
        if (sp.Match(database[dbNum][c]) )  // perform SMART matching
	{
	  count++;
	}
	break;
      case MATCH_IN_SET:
	//cerr << "matchSetCount = " << matchSetCount << "\n";
	//cerr << "c = " << c ;
	if (sp.Match(database[dbNum][c]) )  // perform SMART matching
	{
	  //cerr << " *" ;
	  count++;
	}
	//cerr << "\n" ;
	matchSetCount++;
	if (matchSetCount<matchSetSize[dbNum])
	{
	  c = matchSet[dbNum][matchSetCount]-2; // one for the c++ and the other to shift array acces by one
	}
	else
	{
	  // stoping condition
	  c = databaseEntries[dbNum];
	}
	break;
      case MATCH_NOT_IN_SET:
        if (sp.Match(database[dbNum][c]) )  // perform SMART matching
	{
	  count++;
	}
	// skip the next c and move on with matchSetCount (if possible)
	while ((matchSetCount<matchSetSize[dbNum])&&(c+1 == matchSet[dbNum][matchSetCount]-1))
	{	
	  c++;
	  //cerr << "skip c = " << c << " as current matchSetElement is " << matchSet[dbNum][matchSetCount]-1 << "\n";
	  //cerr << "matchSetCount was " << matchSetCount << "\n";
	  matchSetCount++;
	}
	
	break;
	
	
    }
  }

  
  return count;
}

int* getMatchingMode(int dbNum,char *pattern, int mode, int maxNum)
{
  int* returnArray; 
  int* returnArrayTemp; 

  int count = 0;
  int matchSetCount = 0;
  int c;

  OBSmartsPattern sp;
  sp.Init(pattern);

  returnArrayTemp = new int[databaseEntries[dbNum]];
  
  switch (mode)
    {
    case MATCH_FULL:
      c = 0;
      break;
    case MATCH_IN_SET:
      // start with the first entry in the match set (if match set is not empty)
      if (matchSetSize[dbNum] > 0)
      {
	c =  matchSet[dbNum][0]-1;
      }
      else
      {
	c = databaseEntries[dbNum];
      }
      break;
    case MATCH_NOT_IN_SET:
      c = 0;
      if (matchSetSize[dbNum] > 0)
      {
	// find starting point
	while((c<databaseEntries[dbNum])&&(c == matchSet[dbNum][0]-1))
	  c++;
      }
      else
      {
	mode = MATCH_FULL;
      }
      break;
    }

  for(;c<databaseEntries[dbNum];c++)
  {
    
    switch (mode)
    {
      case MATCH_FULL:
        if (sp.Match(database[dbNum][c]) )  // perform SMART matching
	{
	  returnArrayTemp[count] = c+1;
	  count++;
	}
	break;
      case MATCH_IN_SET:
	//cerr << "matchSetCount = " << matchSetCount << "\n";
	//cerr << "c = " << c ;
	if (sp.Match(database[dbNum][c]) )  // perform SMART matching
	{
	  //cerr << " *" ;
	  returnArrayTemp[count] = c+1;
	  count++;
	}
	//cerr << "\n" ;
	matchSetCount++;
	if (matchSetCount<matchSetSize[dbNum])
	{
	  c = matchSet[dbNum][matchSetCount]-2; // one for the c++ and the other to shift array acces by one
	}
	else
	{
	  // stoping condition
	  c = databaseEntries[dbNum];
	}
	break;
      case MATCH_NOT_IN_SET:
        if (sp.Match(database[dbNum][c]) )  // perform SMART matching
	{
	  returnArrayTemp[count] = c+1;
	  count++;
	}
	// skip the next c and move on with matchSetCount (if possible)
	while ((matchSetCount<matchSetSize[dbNum])&&(c+1 == matchSet[dbNum][matchSetCount]-1))
	{	
	  c++;
	  //cerr << "skip c = " << c << " as current matchSetElement is " << matchSet[dbNum][matchSetCount]-1 << "\n";
	  //cerr << "matchSetCount was " << matchSetCount << "\n";
	  matchSetCount++;
	}
	
	break;
	
	
    }
  }

  // copy into array of right size
  returnArray = new int[count];
  for(c=0;c<count;c++)
  {
    returnArray[c] = returnArrayTemp[c];
  }

  delete []returnArrayTemp;
  sizeLastMatch = count;
  return returnArray;
}

int getSizeLastMatch()
{
  return sizeLastMatch;
}

vector<int> getMatching(int dbNum,char *pattern, int maxNum, int mode)
{
  vector<int> matchingEntries;
  int* returnArray; 
  vector<int>::iterator theIterator;

  //cerr << program_name << " pattern search\n";
  //cerr << program_name << ":dbNum:\t" << dbNum <<" \n";
  //cerr << program_name << ":pattern:\t" << pattern <<" \n";
  OBSmartsPattern sp;
  bool impossible_match;
  int count = 0;
  int c;

  sp.Init(pattern);
 
  for(c=0;c<databaseEntries[dbNum];c++)
  {
     if (sp.Match(database[dbNum][c]) )  // perform SMART matching
     {
       matchingEntries.push_back(c+1);
       count++;
     }    
  }
  return matchingEntries;

}



/*int main(int argc,char **argv)
{
    bool count=false, invert=false, full=false;
    char *FileIn1 = NULL, *FileIn2 = NULL, *Pattern = NULL;
    int dbNum = -1;

    program_name = argv[0];
    FileIn1  = argv[1]; 
    FileIn2  = argv[2]; 
    dbNum = loadDB(FileIn1);
    cout << "Pattern matched " << match(dbNum,"C1=CNC=CC1") << " entries\n";
    //    cout << "Pattern matched " << getMatching(dbNum,"C1=CNC=CC1") << " entries\n";
    cout << getEntryString(dbNum,9);


    cout << "Pattern matched " << match(dbNum,"CC") << " entries\n";
    cout << "Pattern matched " << match(dbNum,"CCc") << " entries\n";
    dbNum = loadDB(FileIn2);
    cout << "Pattern matched " << match(dbNum,"CCc") << " entries\n";
    cout << "Pattern matched " << match(dbNum-1,"CCc") << " entries\n";
}*/

