#!/usr/bin/env python

# for internal use:
# you have to set the LD_LIBRARY_PATH

import os, sys, re
from distutils.core import setup, Extension

module1 = Extension("OBGrep",
                    sources= ["OBGrep/OBGrep.cxx", "OBGrep/OBGrep_wrapper.cxx"],
                    include_dirs = ["/usr/local/include",
                                    "/usr/local/include/openbabel/", # should direct to the include dirs of OB
                                    "./" # needed for math
                                    ],
                    library_dirs = ["/usr/local/lib"], # should link to the openbabel.so library
                    libraries = ["openbabel"],
                    )

setup(name="PyOBGrep",
      version = "0.1",
      description = "Python interface to the OBGrep(OpenBabel Grep)",
      author = "Andreas Karwath",
      author_email = "karwath@informatik.uni-freiburg.de",
      url = "http://www.informatik.uni-freiburg.de/~karwath",
      license = "GPL",

      maintainer = "Andreas Karwath",
      maintainer_email = "karwath@informatik.uni-freiburg.de",

      long_description = "",

      packages = ["OBGrep"],
      ext_modules = [module1]
      )
